// Reader.cpp: implementation of the Reader class.
//
//////////////////////////////////////////////////////////////////////

#include "Reader.h"
#include <string.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Reader::Reader(const char * filename)
{
	m_file = fopen(filename, "r");
	m_lineNo = 0;
}

Reader::~Reader()
{
	if (m_file != NULL)
	{
		fclose(m_file);
		m_file = NULL;
	}
}

bool Reader::isOk()
{
	return(m_file != NULL);
}

// read non-empty line

bool Reader::readLine(char *buffer, long bufLen)
{
	do 
	{
		++m_lineNo;

		if (NULL == fgets(buffer, bufLen, m_file))
		{
			return false;
		}
		else
		{
			// remove comments
			char * p = strchr(buffer, '#');
			if (p != NULL)
			{
				*p = '\0';
			}

			// remove trailing spaces and control characters
			p = buffer + strlen(buffer);
			while ((p >= buffer) && (*p <= ' '))
			{
				*p = '\0';
				--p;
			}
		}
	} while (strlen(buffer) == 0);
	return true;
}
